[arch-commits] Commit in eclipse/repos/community-x86_64 (4 files)
Jan Steffens
heftig at archlinux.org
Tue Jul 17 20:45:35 UTC 2018
Date: Tuesday, July 17, 2018 @ 20:45:34
Author: heftig
Revision: 361170
archrelease: copy trunk to community-x86_64
Added:
eclipse/repos/community-x86_64/PKGBUILD
(from rev 361169, eclipse/trunk/PKGBUILD)
eclipse/repos/community-x86_64/commonify
(from rev 361169, eclipse/trunk/commonify)
Deleted:
eclipse/repos/community-x86_64/PKGBUILD
eclipse/repos/community-x86_64/commonify
-----------+
PKGBUILD | 204 +++++++++++++++++++------------------
commonify | 329 +++++++++++++++++++++++++++++++-----------------------------
2 files changed, 278 insertions(+), 255 deletions(-)
Deleted: PKGBUILD
===================================================================
--- PKGBUILD 2018-07-17 20:36:11 UTC (rev 361169)
+++ PKGBUILD 2018-07-17 20:45:34 UTC (rev 361170)
@@ -1,98 +0,0 @@
-# $Id$
-# Maintainer: Jan Alexander Steffens (heftig) <jan.steffens at gmail.com>
-# Contributor: Ionut Biru <ibiru at archlinux.org>
-# Contributor: Paul Mattal <paul at archlinux.org>
-# Contributor: Andrew Wright <andreww at photism.org>
-# Contributor: Andreas W. Hauser <andy-aur at splashground.de>
-# Contributor: Marco Crosio <marco.crosio at gmail.com>
-
-pkgbase=eclipse
-pkgname=(eclipse-{common,java,jee,cpp,php,javascript})
-pkgver=4.8
-pkgrel=1
-_release=photon-R
-pkgdesc="Highly extensible IDE"
-license=(EPL)
-arch=(x86_64)
-url="https://eclipse.org"
-makedepends=(python3)
-options=(!emptydirs)
-source=(commonify)
-noextract=()
-
-for _pkg in ${pkgname[@]}; do
- [[ $_pkg == 'eclipse-common' ]] && continue
- source+=(http://ftp-stud.fht-esslingen.de/pub/Mirrors/eclipse/technology/epp/downloads/release/${_release/-//}/$_pkg-$_release-linux-gtk-x86_64.tar.gz)
- noextract+=($_pkg-$_release-linux-gtk-x86_64.tar.gz)
- eval "package_$_pkg() { _package $_pkg; }"
-done
-
-sha256sums=('da1eaf6239cb0c2b5009cd8c261e96e7b17a7536b12fe60fcb1e903f5e67dbdc'
- 'd6f5ee4e5ced59d2cf6a9b7a992b7d01eb71480cd2353844ba47eb5c55a41816'
- '3bd00147fe545d1263dd10cdba9850d1fbeaed463582162bb15ddd0d6cfbd3ee'
- 'aa6addf9748156402075db28d6fe839bc63e996075c3894550ca367b68e51b01'
- 'adec5f5a676486d06ad6d2df40c83a754a498f022501b4b055573f7e56549615'
- 'e267b7b52ed16e858f938a4f2a145a422582543d619e4ccba2744a499c6a0a0a')
-
-prepare() {
- local pkg
- for pkg in ${pkgname[@]}; do
- mkdir $pkg
- [[ $pkg == eclipse-common ]] && continue
- bsdtar -xf "$pkg-$_release-linux-gtk-x86_64.tar.gz" -C $pkg --strip-components 1
- done
-}
-
-build() {
- mkdir eclipse-common/dropins
- touch eclipse-common/dropins/.keep
- ./commonify --identical ${pkgname[@]}
-}
-
-package_eclipse-common() {
- pkgdesc+=" (common files)"
- depends=("java-environment>=8" webkit2gtk unzip)
-
- install -d "$pkgdir/usr/lib"
- cp -a eclipse-common "$pkgdir/usr/lib/eclipse"
-
- install -D /dev/stdin "$pkgdir/usr/bin/eclipse" <<END
-#!/bin/bash
-export ECLIPSE_HOME=/usr/lib/eclipse
-exec \$ECLIPSE_HOME/eclipse "\$@"
-END
-
- install -Dm644 /dev/stdin "$pkgdir/usr/share/applications/eclipse.desktop" <<END
-[Desktop Entry]
-Name=Eclipse
-Comment=A Java Development Environment
-Icon=eclipse
-Exec=eclipse
-Terminal=false
-Type=Application
-Categories=Development;IDE;Java;
-StartupNotify=true
-END
-
- local i
- for i in 16 22 24 32 48 64 128 256 512 1024; do
- install -Dm644 eclipse-common/plugins/org.eclipse.platform_*/eclipse$i.png \
- "$pkgdir/usr/share/icons/hicolor/${i}x$i/apps/eclipse.png"
- done
-}
-
-_package() {
- local variant=${1#eclipse-}
- pkgdesc+=" (${variant^^} variant)"
- depends=(eclipse-common)
- provides=("eclipse=$pkgver-$pkgrel")
- conflicts=(eclipse)
-
- case $variant in
- java) replaces=(eclipse) ;;
- cpp) replaces=(eclipse-cdt) ;;
- esac
-
- install -d "$pkgdir/usr/lib"
- cp -a $1 "$pkgdir/usr/lib/eclipse"
-}
Copied: eclipse/repos/community-x86_64/PKGBUILD (from rev 361169, eclipse/trunk/PKGBUILD)
===================================================================
--- PKGBUILD (rev 0)
+++ PKGBUILD 2018-07-17 20:45:34 UTC (rev 361170)
@@ -0,0 +1,106 @@
+# $Id$
+# Maintainer: Jan Alexander Steffens (heftig) <jan.steffens at gmail.com>
+# Contributor: Ionut Biru <ibiru at archlinux.org>
+# Contributor: Paul Mattal <paul at archlinux.org>
+# Contributor: Andrew Wright <andreww at photism.org>
+# Contributor: Andreas W. Hauser <andy-aur at splashground.de>
+# Contributor: Marco Crosio <marco.crosio at gmail.com>
+
+pkgbase=eclipse
+pkgname=(eclipse-{common,java,jee,cpp,php,javascript,rust})
+pkgver=4.8
+pkgrel=2
+_release=photon-R
+pkgdesc="Highly extensible IDE"
+license=(EPL)
+arch=(x86_64)
+url="https://eclipse.org"
+makedepends=(python3)
+source=(commonify)
+noextract=()
+
+_sourcename() {
+ case $1 in
+ eclipse-common*) return 1 ;;
+ eclipse-rust ) echo $1-$_release-incubation-linux-gtk-x86_64.tar.gz ;;
+ * ) echo $1-$_release-linux-gtk-x86_64.tar.gz ;;
+ esac
+}
+
+for _pkg in ${pkgname[@]}; do
+ _src=$(_sourcename $_pkg) || continue
+ source+=(http://ftp-stud.fht-esslingen.de/pub/Mirrors/eclipse/technology/epp/downloads/release/${_release/-//}/$_src)
+ noextract+=($_src)
+ eval "package_$_pkg() { _package $_pkg; }"
+done
+
+sha256sums=('70ae1934385b0b7c25e5a76bfcd6d092bfd8d19ce451c3d909afa3cf2448452e'
+ 'd6f5ee4e5ced59d2cf6a9b7a992b7d01eb71480cd2353844ba47eb5c55a41816'
+ '3bd00147fe545d1263dd10cdba9850d1fbeaed463582162bb15ddd0d6cfbd3ee'
+ 'aa6addf9748156402075db28d6fe839bc63e996075c3894550ca367b68e51b01'
+ 'adec5f5a676486d06ad6d2df40c83a754a498f022501b4b055573f7e56549615'
+ 'e267b7b52ed16e858f938a4f2a145a422582543d619e4ccba2744a499c6a0a0a'
+ 'cf4bb11a656eb4b5002bf51e6bc2841e710571250e97f0671897c18d61308dff')
+
+prepare() {
+ local pkg src
+ for pkg in ${pkgname[@]}; do
+ mkdir $pkg
+ src=$(_sourcename $pkg) || continue
+ bsdtar -xf $src -C $pkg --strip-components 1
+ done
+}
+
+build() {
+ mkdir eclipse-common/dropins
+ touch eclipse-common/dropins/.keep
+ ./commonify --identical ${pkgname[@]}
+}
+
+package_eclipse-common() {
+ pkgdesc+=" (common files)"
+ depends=("java-environment>=8" webkit2gtk unzip)
+
+ install -d "$pkgdir/usr/lib"
+ cp -a eclipse-common "$pkgdir/usr/lib/eclipse"
+
+ install -D /dev/stdin "$pkgdir/usr/bin/eclipse" <<END
+#!/bin/bash
+export ECLIPSE_HOME=/usr/lib/eclipse
+exec \$ECLIPSE_HOME/eclipse "\$@"
+END
+
+ install -Dm644 /dev/stdin "$pkgdir/usr/share/applications/eclipse.desktop" <<END
+[Desktop Entry]
+Name=Eclipse
+Comment=A Java Development Environment
+Icon=eclipse
+Exec=eclipse
+Terminal=false
+Type=Application
+Categories=Development;IDE;Java;
+StartupNotify=true
+END
+
+ local i
+ for i in 16 22 24 32 48 64 128 256 512 1024; do
+ install -Dm644 eclipse-common/plugins/org.eclipse.platform_*/eclipse$i.png \
+ "$pkgdir/usr/share/icons/hicolor/${i}x$i/apps/eclipse.png"
+ done
+}
+
+_package() {
+ local variant=${1#eclipse-}
+ pkgdesc+=" (${variant^^} variant)"
+ depends=(eclipse-common)
+ provides=("eclipse=$pkgver-$pkgrel")
+ conflicts=(eclipse)
+
+ case $variant in
+ java) replaces=(eclipse) ;;
+ cpp) replaces=(eclipse-cdt) ;;
+ esac
+
+ install -d "$pkgdir/usr/lib"
+ cp -a $1 "$pkgdir/usr/lib/eclipse"
+}
Deleted: commonify
===================================================================
--- commonify 2018-07-17 20:36:11 UTC (rev 361169)
+++ commonify 2018-07-17 20:45:34 UTC (rev 361170)
@@ -1,157 +0,0 @@
-#!/usr/bin/env python3
-from argparse import ArgumentParser
-from asyncio.subprocess import DEVNULL, PIPE
-from asyncio import (get_event_loop, gather, BoundedSemaphore, create_subprocess_exec,
- IncompleteReadError)
-from enum import Enum, auto
-from logging import getLogger, basicConfig, INFO
-from os import cpu_count
-from pathlib import Path
-from sys import exit
-
-
-logger = getLogger(__name__)
-
-
-class Mode(Enum):
- identical = auto()
- nonconflicting = auto()
-
-
-def parse_args(args=None):
- parser = ArgumentParser(description='Extract common files.')
-
- modes = parser.add_mutually_exclusive_group(required=True)
- for m in Mode:
- modes.add_argument(f'--{m.name}', dest='mode', action='store_const', const=m,
- help=f'extract {m.name} common files')
-
- parser.add_argument('-n', '--dry-run', action='store_true', help='Dry run (do nothing)')
- parser.add_argument('common_dir', metavar='COMMON_DIR',
- help='common files directory to move to')
- parser.add_argument('targets', nargs='+', metavar='INPUT_DIR', help='directory to move from')
-
- return parser.parse_args(args)
-
-
-class bounded_exec:
- semaphore = BoundedSemaphore(value=cpu_count() + 1)
-
- def __init__(self, *args, **kwargs):
- self.args = args
- self.kwargs = kwargs
-
- async def __aenter__(self):
- await self.semaphore.acquire()
- p = self.process = await create_subprocess_exec(*self.args, **self.kwargs)
- return p
-
- async def __aexit__(self, exc_type, exc, tb):
- p = self.process
- if p.returncode is None:
- try:
- p.kill()
- except:
- pass
- await p.wait()
- self.semaphore.release()
-
-
-class DiffError(RuntimeError):
- pass
-
-
-async def diff(file1, file2):
- async with bounded_exec('diff', '-q', str(file1), str(file2),
- stdin=DEVNULL, stdout=DEVNULL, stderr=DEVNULL) as p:
- ret = await p.wait()
-
- if ret != 0:
- raise DiffError()
-
-
-async def identical(files):
- if len(files) < 2:
- return True
- first, *rest = files
- fut = gather(*[diff(first, f) for f in rest])
- try:
- await fut
- except DiffError as e:
- return False
- else:
- return True
- finally:
- fut.cancel()
-
-def commonify_file(common_file, files):
- common_file.parent.mkdir(parents=True, exist_ok=True)
- first, *rest = files
- first.rename(common_file)
- for f in rest:
- f.unlink()
-
-
-async def commonify_identical(common_file, files, *, dry_run=False):
- if await identical(files):
- if not dry_run:
- commonify_file(common_file, files)
- return 1
- else:
- logger.info('Divergent file: %s', common_file)
- return 0
-
-
-async def find_files(path):
- async with bounded_exec('find', str(path), '-type', 'f', '-print0',
- stdin=DEVNULL, stdout=PIPE, stderr=DEVNULL) as p:
- while True:
- try:
- line = await p.stdout.readuntil(b'\x00')
- except IncompleteReadError as e:
- line = e.partial
- if not line:
- break
- raise
- yield Path(line[:-1].decode())
-
-
-async def scan(target, files_targetfiles):
- n = 0
- async for f in find_files(target):
- files_targetfiles.setdefault(f.relative_to(target), []).append(f)
- n += 1
- logger.info('%s: Found %d files', target, n)
-
-
-def arg_dir(s):
- p = Path(s)
- if not p.is_dir():
- raise ValueError(f'{s!r} is not a directory')
- return p
-
-
-async def main(settings):
- ignore_len = settings.mode == Mode.nonconflicting
- common_dir = arg_dir(settings.common_dir)
- targets = [arg_dir(t) for t in settings.targets]
-
- files_targetfiles = {}
- await gather(*[scan(t, files_targetfiles) for t in targets])
-
- results = await gather(*[
- commonify_identical(common_dir / f, tf, dry_run=settings.dry_run)
- for f, tf in files_targetfiles.items()
- if ignore_len or len(tf) == len(targets)
- ])
-
- logger.info('%s: %d %s files',
- common_dir, sum(results), settings.mode.name)
- return 0
-
-
-if __name__ == '__main__':
- basicConfig(level=INFO)
- settings = parse_args()
- loop = get_event_loop()
- exit(loop.run_until_complete(main(settings)))
Copied: eclipse/repos/community-x86_64/commonify (from rev 361169, eclipse/trunk/commonify)
===================================================================
--- commonify (rev 0)
+++ commonify 2018-07-17 20:45:34 UTC (rev 361170)
@@ -0,0 +1,172 @@
+#!/usr/bin/env python3
+from argparse import ArgumentParser
+from asyncio.subprocess import DEVNULL, PIPE
+from asyncio import (get_event_loop, gather, BoundedSemaphore, create_subprocess_exec,
+ IncompleteReadError)
+from enum import Enum, auto
+from logging import getLogger, basicConfig, INFO, DEBUG
+from os import cpu_count, renames, remove, removedirs
+from os.path import isdir, join as pjoin, split as psplit, relpath
+from sys import exit
+
+
+logger = getLogger(__name__)
+
+
+class Mode(Enum):
+ identical = auto()
+ nonconflicting = auto()
+
+
+def parse_args(args=None):
+ parser = ArgumentParser(description='Extract common files.')
+
+ modes = parser.add_mutually_exclusive_group(required=True)
+ for m in Mode:
+ modes.add_argument(f'--{m.name}', dest='mode', action='store_const', const=m,
+ help=f'extract {m.name} common files')
+
+ parser.add_argument('-n', '--dry-run', action='store_true', help='Dry run (do nothing)')
+ parser.add_argument('-v', '--verbose', action='store_true', help='Raise verbosity')
+ parser.add_argument('common_dir', metavar='COMMON_DIR',
+ help='common files directory to move to')
+ parser.add_argument('targets', nargs='+', metavar='INPUT_DIR', help='directory to move from')
+
+ return parser.prog, parser.parse_args(args)
+
+
+class bounded_exec:
+ semaphore = BoundedSemaphore(value=cpu_count() + 1)
+
+ def __init__(self, *args, **kwargs):
+ self.args = args
+ self.kwargs = kwargs
+
+ async def __aenter__(self):
+ await self.semaphore.acquire()
+ p = self.process = await create_subprocess_exec(*self.args, **self.kwargs)
+ return p
+
+ async def __aexit__(self, exc_type, exc, tb):
+ p = self.process
+ if p.returncode is None:
+ try:
+ p.kill()
+ except:
+ pass
+ await p.wait()
+ self.semaphore.release()
+
+
+class DiffError(RuntimeError):
+ pass
+
+
+async def diff(file1, file2):
+ async with bounded_exec('diff', '-q', file1, file2,
+ stdin=DEVNULL, stdout=DEVNULL, stderr=DEVNULL) as p:
+ ret = await p.wait()
+
+ if ret != 0:
+ raise DiffError()
+
+
+async def identical(files):
+ if len(files) < 2:
+ return True
+ first, *rest = files
+ fut = gather(*[diff(first, f) for f in rest])
+ try:
+ await fut
+ except DiffError as e:
+ return False
+ else:
+ return True
+ finally:
+ fut.cancel()
+
+
+def removes(path):
+ remove(path)
+ head, tail = psplit(path)
+ if head and tail:
+ try:
+ removedirs(head)
+ except OSError:
+ pass
+
+
+def commonify_file(common_file, files):
+ first, *rest = files
+ renames(first, common_file)
+ for f in rest:
+ removes(f)
+
+
+async def find_files(path):
+ async with bounded_exec('find', path, '-type', 'f', '-print0',
+ stdin=DEVNULL, stdout=PIPE, stderr=DEVNULL) as p:
+ while True:
+ try:
+ line = await p.stdout.readuntil(b'\x00')
+ except IncompleteReadError as e:
+ line = e.partial
+ if not line:
+ break
+ raise
+ yield line[:-1].decode()
+
+
+async def scan_one(target, files):
+ n = 0
+ async for f in find_files(target):
+ files.setdefault(relpath(f, target), []).append(target)
+ n += 1
+ logger.info('Found %d files in %r', n, target)
+
+
+async def scan(targets):
+ files = {}
+ await gather(*[scan_one(t, files) for t in targets])
+ return files
+
+
+def arg_dir(s):
+ if not isdir(s):
+ raise ValueError(f'{s!r} is not a directory')
+ return s
+
+
+async def commonify(settings, common_file, targets):
+ files = [pjoin(t, common_file) for t in targets]
+
+ if not await identical(files):
+ logger.info("Divergent file %r", common_file)
+ return False
+
+ if len(files) == len(settings.targets):
+ logger.debug("Identical file %r", common_file)
+ elif settings.mode == Mode.nonconflicting:
+ logger.debug("Nonconflicting file %r in %r", common_file, targets)
+ else:
+ logger.debug("Partly identical file %r in %r", common_file, targets)
+ return False
+
+ if not settings.dry_run:
+ commonify_file(pjoin(settings.common_dir, common_file), files)
+
+ return True
+
+
+async def main(settings):
+ files = await scan(arg_dir(t) for t in settings.targets)
+ results = await gather(*[commonify(settings, *ft) for ft in files.items()])
+ logger.info('%d %s files in %r', sum(results), settings.mode.name, settings.common_dir)
+ return 0
+
+
+if __name__ == '__main__':
+ prog, settings = parse_args()
+ basicConfig(level=DEBUG if settings.verbose else INFO, format=f"{prog}: %(message)s")
+ loop = get_event_loop()
+ exit(loop.run_until_complete(main(settings)))
More information about the arch-commits
mailing list